varsnap.js
==========

[![Codeship Status for albertyw/varsnap.js](https://app.codeship.com/projects/772d6dd0-7616-0137-b181-4a74f06c083c/status?branch=master)](https://app.codeship.com/projects/349777)

https://www.varsnap.com/

Javascript VarSnap Client.  For use in both browser and node.js

Installation
------------

Install from NPM - `npm install --save varsnap`

Configuration
-------------

The varsnap decorator needs to be configured with a `config` object with these variables:

 - `varsnap` - Should be either `true` or `false`.  Varsnap will be disabled if the variable is anything other than `true`.
 - `env` - If set to `development`, the client will receive events from production.  If set to `production`, the client will emit events.
 - `producerToken` - Only clients with this token may emit production snapshots.  Copied from https://www.varsnap.com/user/
 - `consumerToken` - Only clients with this token may emit development snapshots.  Copied from https://www.varsnap.com/user/

Usage
-----

Wrap your functions with the varsnap decorator for any function you'd like to make better:

```javascript
// Node.js
var varsnap = require('varsnap');

// Browser
var varsnap = window.varsnap;

// Configuration
varsnap.config = {
  varsnap: 'true',
  env: 'production',
  producerToken: 'producer-abcd'
};

// Integration
function example(x, y, z) {
  // ...
}
example = varsnap(example);

example(1, 2, 3);
```

See `example/example.js` for example usage.

Testing
-------

Import and call the included VarSnap mocha test case. (You must run the script with `mocha` instead of `node`):

```javascript
var varsnap = require('varsnap');

// Load the modules where varsnap is being used
// Assume that VarSnap config is set in here, otherwise see the configuration
// options above
require('./example');

varsnap.TestCase();
```

See `example/test.js` for example usage.

Release
-------

1.  Update Changelog with new version
2.  Update `const version` in `core.js`
3.  Update package.json version and run `npm install`
4.  Update `.uglify.json` and `.uglify.min.json`
5.  Run `npm run package`
6.  Git commit and tag
7.  `npm publish`
8.  Upload `dist/*` to https://github.com/albertyw/varsnap.js/releases
